/*! \file Commons.cpp
 *
 */

#include "include/Commons.h"

using namespace std;

C1::C1(int ns, int l_max) {
	nlmmt = 2 * (l_max * (l_max + 2));
	nsph = ns;
	lm = l_max;

	rmi = new complex<double>*[lm];
	rei = new complex<double>*[lm];
	for (int ri = 0; ri < lm; ri++) {
		rmi[ri] = new complex<double>[nsph];
		rei[ri] = new complex<double>[nsph];
	}
	w = new complex<double>*[nlmmt];
	for (int wi = 0; wi < nlmmt; wi++) w[wi] = new complex<double>[4];
	vints = new complex<double>*[nsph];
	rc = new double*[nsph];
	for (int vi = 0; vi < nsph; vi++) {
		rc[vi] = new double[lm];
		vints[vi] = new complex<double>[16];
	}
	fsas = new complex<double>[nsph];
	sscs = new double[nsph];
	sexs = new double[nsph];
	sabs = new double[nsph];
	sqscs = new double[nsph];
	sqexs = new double[nsph];
	sqabs = new double[nsph];
	gcsv = new double[nsph];;
	rxx = new double[nsph];
	ryy = new double[nsph];
	rzz = new double[nsph];
	ros = new double[nsph];
	iog = new int[nsph];
	nshl = new int[nsph];

	sas = new complex<double>**[nsph];
	for (int si = 0; si < nsph; si++) {
		sas[si] = new complex<double>*[2];
		sas[si][0] = new complex<double>[2];
		sas[si][1] = new complex<double>[2];
	}
}

C1::~C1() {
	delete[] rmi;
	delete[] rei;
	for (int wi = 1; wi <= nlmmt; wi++) delete[] w[wi];
	for (int vi = 1; vi <= nsph; vi++) {
		delete[] rc[nsph - vi];
		delete[] vints[nsph - vi];
	}
	for (int si = 1; si <= nsph; si++) {
		delete[] sas[nsph - si][1];
		delete[] sas[nsph - si][0];
	}
	delete[] fsas;
	delete[] sscs;
	delete[] sexs;
	delete[] sabs;
	delete[] sqscs;
	delete[] sqexs;
	delete[] sqabs;
	delete[] gcsv;
	delete[] rxx;
	delete[] ryy;
	delete[] rzz;
	delete[] ros;
	delete[] iog;
	delete[] nshl;
}

C2::C2(int ns, int nl, int npnt, int npntts) {
	nsph = ns;
	int max_n = (npnt > npntts) ? npnt : npntts;
	nhspo = 2 * max_n - 1;
	ris = new complex<double>[nhspo];
	dlri = new complex<double>[nhspo];
	vkt = new complex<double>[nsph];
	dc0 = new complex<double>[nl];
	vsz = new double[nsph];
}

C2::~C2() {
	delete[] ris;
	delete[] dlri;
	delete[] vkt;
	delete[] dc0;
	delete[] vsz;
}
